<!-- 订单详情 -->
<template>
  <div>
    <el-dialog :append-to-body="true" :close-on-click-modal="false" title="订单详情" :visible.sync="Show" width="1000px">
      <div v-loading="m_tableLoading">
        <el-form label-position="left">

          <el-form-item label="状态:" label-width="80px">
            <span class="fs18" :class="info.status|order_status_class"> {{info.status |  BaseData('orders','status')}}</span>
            <el-button v-if="info.status==1" class="ml20" @click="clickDeliver" type="primary" size="mini"><span>确认发货</span></el-button>
            <el-button :loading="payLoading" v-if="info.status==0" class="ml20" @click="clickSurePay" type="primary" size="mini"><span>确认付款</span></el-button>
          </el-form-item>
          <div class="od-box ">
            <el-form-item label="订单号:" label-width="80px">
              <span>{{info.order_no}}</span>
            </el-form-item>

            <el-form-item label="创建时间:" label-width="80px">
              <span>{{info.created_at}}</span>
            </el-form-item>


            <el-form-item label="付款时间" label-width="80px">
              <span v-if="info.status >= 1">{{info.pay_time}}</span>
              <span v-else>--</span>
            </el-form-item>

          </div>

          <el-form-item label="收货地址:" label-width="80px">
            <div> <span class="mr20">{{info.receiver}}</span>
              <span class="mr20">{{info.receiver_mobile}}</span>
              <span>{{info.address_text}}{{info.address}}</span>
              <el-button v-if="info.status==1" @click="clickEidtAddress" class="ml20" type="text">修改</el-button>
            </div>
          </el-form-item>


          <div class="od-box ">

            <el-form-item label="开增值性发票:" label-width="130px">
              <span>{{receipt && receipt.receipt_required ? receipt.receipt_required : '--'}}</span>
            </el-form-item>

            <el-form-item label="公司名:" label-width="130px">
              <span>{{receipt && receipt.company_name ? receipt.company_name : '--'}}</span>
            </el-form-item>

            <el-form-item label="类型:" label-width="130px">
              <span>{{receipt && receipt.type ? showReceiptType(receipt.type) : '--'}}</span>
            </el-form-item>

            <el-form-item label="公司电话:" label-width="130px">
              <span>{{receipt && receipt.company_phone ? receipt.company_phone : '--'}}</span>
            </el-form-item>


            <el-form-item label="公司组织代码:" label-width="130px">
              <span>{{receipt && receipt.company_code ? receipt.company_code : '--'}}</span>
            </el-form-item>

            <el-form-item label="名称:" label-width="130px">
              <span>{{receipt && receipt.name ? receipt.name : '--'}}</span>
            </el-form-item>

          </div>

          <div class="mb20" v-if="info.order_packages.length">
            <h3>包裹信息</h3>
            <hr class="mt10 mb10">

            <el-table size="mini" :data="info.order_packages" border style="width: 100%">
              <el-table-column label="商品" align="center">
                <template slot-scope="scope"> <img class="tb-img-b" v-for="(item ,index ) in findGoodsImgs(scope.row.id)" :src="item" alt=""></template>
              </el-table-column>

              <el-table-column align="center" prop="express" label="快递"></el-table-column align="center">
              <el-table-column align="center" prop="express_id" label="快递单号">
                <template slot-scope="scope">
                  <div v-for="(item,index) in separateSn(scope.row.express_sn)" :key="index">
                    <el-button type="text" @click="showExpressInfo(scope.row,item)"> {{item}} </el-button>
                  </div>
                </template>
              </el-table-column>
              <el-table-column align="center" prop="created_at" label="发货时间"></el-table-column>

            </el-table>

          </div>

          <div>
            <h3>商品信息</h3>
            <hr class="mt10 mb10">
            <el-table size="mini" :data="info.order_goods" border style="width: 100%">
              <el-table-column label="图片" width="110" align="center">
                <template slot-scope="scope"> <img class="tb-img " :src="scope.row.images" alt=""></template>
              </el-table-column>
              <el-table-column align="center" prop="title" label="名称"></el-table-column align="center">
               <el-table-column align="center" prop="option_title" label="规格"></el-table-column align="center">
              <el-table-column width="110" align="center" prop="price" label="单价"></el-table-column>
              <el-table-column width="80" align="center" prop="num" label="数量"></el-table-column>
              <el-table-column width="110" align="center" prop="original_price" label="原价"></el-table-column>
              <el-table-column width="110" v-if="info.status==1" align="center" prop="package_id" label="发货状态">
                <template slot-scope="scope">

                  <div><span :class="scope.row.package_id | package_id_class">{{scope.row.package_id | package_id}}</span></div>
                </template>
              </el-table-column>
              <el-table-column width="110" align="center" prop="package_id" label="链接">
                <template slot-scope="scope">
                  <div v-if="scope.row.cupon_url">
                    <el-button @click="open(scope.row.cupon_url)" type="text" size="mini">优惠券链接</el-button>
                  </div>
                  <div v-if="scope.row.item_url">
                    <el-button @click="open(scope.row.item_url)" type="text" size="mini"> 宝贝链接</el-button>
                  </div>

                </template>
              </el-table-column>

            </el-table>

            <div class=" flex flex-m mt10">
              <div class="mr20">商品小计：￥{{info.goods_amount}}</div>
              <div class="mr5">运费：￥{{info.express_amount}}</div>
              <el-button v-if="info.status==0" @click="showSetPirce('1')" class="mr20" type="text">修改</el-button>
              <div class="mr5">实付款：<span class="m_red">￥{{info.total_amount}}</span> </div>
              <el-button v-if="info.status==0" @click="showSetPirce('2')" class="mr20" type="text">修改</el-button>

            </div>

          </div>

        </el-form>
      </div>
      <div slot="footer">
        <el-button @click="Show = false">关 闭</el-button>
        <el-button type="primary" @click="handelSetMenu">确 定</el-button>
      </div>
    </el-dialog>

    <editAddress @save-after="getInfo" v-if="editAddressShow" v-model="editAddressShow" :info="info" />
    <deliver @save-after="deliverSaveDeliver" v-if="deliverShow" v-model="deliverShow" :info="info" />
    <expressInfo v-model="expressInfoShow" v-if="expressInfoShow" :info="expressData" />
    <setPirce @save-after="deliverSaveDeliver" v-model="setPirceShow" v-if="setPirceShow" :info="setPirceData" />
  </div>
</template>

<script>
import setPirce from './setPirce'
import expressInfo from './expressInfo'
import deliver from './deliver'
import editAddress from './editAddress'
export default {
  name: 'addFormDialog',
  components: { editAddress, deliver, expressInfo, setPirce },
  props: {
    value: {
      required: true,
      type: Boolean,
    },
    id: {
      type: [String, Number]
    },
  },

  computed: {
    Show: {
      get() {
        return this.value
      },
      set(v) {
        this.$emit('input', v)
      }
    }
  },
  data() {
    return {
      m_tableLoading: false,
      info: {
        order_packages: [],
        order_goods: []
      },
      editAddressShow: false,
      deliverShow: false,
      expressInfoShow: false,
      _expressData: {},
      expressData: {
        express_id: '',
        express_sn: '',
        custom_code: ''
      },

      setPirceShow: false,
      setPirceData: {
        type: '',
        express_amount: '', //运费
        total_amount: '', //总额
        id: ''
      },
      sn: null,
      payLoading: false,
      receipt: {}

    }
  },


  mounted() {
    this._expressData = this._dep(this.expressData);
    this.init()
  },

  methods: {
    //初始化方法
    init() {
      this.getInfo()
    },
    separateSn (rawSn) {
      // console.log(rawSn)
      let data = rawSn.split('|').map((el) => el.trim());
      // console.log(data)
      return data
    },
    getInfo() {
      this.m_tableLoading = true
      this.m_api.order_detail({ id: this.id }).then(res => {
        console.log(res.data);
        this.info = res.data
        this.receipt = res.data.receipt;
        this.m_tableLoading = false
      }).catch(err => {
        this.m_tableLoading = false
      })
    },

    //发货成功
    deliverSaveDeliver() {
      this.getInfo()
      this.$emit('save-after')
    },

    handelSetMenu() {
      this.$emit('save-after')
      this.Show = false
    },

    clickEidtAddress() {
      this.editAddressShow = true
    },

    clickDeliver() {
      this.deliverShow = true
    },

    showExpressInfo(row,sn) {
      this.expressData = this._dep(this._expressData)
      this.expressData.express_id = row.express_id
      this.expressData.express_sn = sn
      this.expressData.custom_code = row.custom_code
       this.expressData.id = row.id
      this.expressInfoShow = true
    },

    showSetPirce(type) {
      this.setPirceData.type = type
      this.setPirceData.express_amount = this.info.express_amount
      this.setPirceData.total_amount = this.info.total_amount
      this.setPirceData.id = this.info.id
      this.setPirceShow = true
    },

    //确认付款
    clickSurePay() {

      this.$confirm(`是否确定付款该订单?`, '提示', {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        this.payLoading = true
        this.m_api.system_pay({ id: this.info.id }).then(res => {
          this.payLoading = false
          this.m_success('设置成功')
          this.getInfo()
          this.$emit('save-after')
        }).catch(err => {
          this.payLoading = false
        })

      }).catch(() => {
        //取消删除
      })
    },

    findGoods(v) {
      let goods = this.info.order_goods.filter(i => i.package_id == v)
      return goods
    },

    findGoodsImgs(v) {
      let goods = this.findGoods(v)
      let imgs = goods.map(i => i.images)
      return imgs
    },

    open(url) {
    //  window.open(url, "_blank");
    this.m_copy(url,()=>{
      this.m_success('复制成功')
    })
    },
    showReceiptType(type) {
      if (type.toLowerCase() == 'company') {
        return '企业';
      } else if(type.toLowerCase() == 'personal') {
        return '个人';
      }
      return type;
    }
  },
  watch: {

  },
  filters: {
    package_id(v) {
      if (v == 0) {
        return '未发货'
      } else {
        return '已发货'
      }
    },
    package_id_class(v) {
      if (v == 0) {
        return 'm_red'
      } else {
        return 'm_green'
      }
    },
  }
}

</script>
<style lang='scss' scoped>
.od-box {
  display: grid;
  grid-template-columns: 33.3% 33.33% 33.33%;
  grid-row-gap: 1px;
  grid-column-gap: 1px;
}

.tb-img {
  width: 88px;
  height: 88px;
}

.tb-img-b {
  width: 44px;
  height: 44px;
  margin-right: 5px;
}
</style>